pub type Instructions = Vec<Code>;

#[derive(Debug, Clone, PartialEq)]
pub enum Code {
    Constant(usize),
    True,
    False,
    Array(usize),

    Add,
    Subtract,
    Mulitply,
    Divide,
    Negate,
    GreaterThan,
    GreaterThanEquals,
    LessThan,
    LessThanEquals,
    Equals,
    NotEquals,

    Call(usize),
    Return(bool),

    Jump(usize),
    JumpIfNot(usize),

    GetGlobal(usize),
    SetGlobal(usize),

    GetLocal(usize),
    SetLocal(usize),
    
    Pop,
}